/* <INSERT COPYRIGHT & LICENSE TEXT HERE> */

#ifndef TPL1401_H_
#define TPL1401_H_

#include <stdint.h>


//**********************************************************************************
//
// Function prototypes
//
//**********************************************************************************



//**********************************************************************************
//
// Device commands
//
//**********************************************************************************



//**********************************************************************************
//
// Register definitions
//
//**********************************************************************************


/* Register 0x21 (DPOT_POSITION) definition
 * |---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
 * |         Bit 15         |         Bit 14         |         Bit 13         |         Bit 12         |         Bit 11         |         Bit 10         |          Bit 9         |          Bit 8         |          Bit 7         |          Bit 6         |          Bit 5         |          Bit 4         |          Bit 3         |          Bit 2         |          Bit 1         |          Bit 0         |
 * |---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
 * |            0           |            0           |            0           |            0           |                                                                                                                    DPOT_POS[7:0][9:0]                                                                                                                   |            0           |            0           |
 * |---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
 */

    /* DPOT_POSITION register address */
    #define DPOT_POSITION_ADDRESS											((uint8_t) 0x21)

    /* DPOT_POSITION default (reset) value */
    #define DPOT_POSITION_DEFAULT											((uint16_t) 0x0000)

    /* DPOT_POSITION register field masks */
    #define DPOT_POSITION_DPOT_POS[7:0]_MASK								((uint16_t) 0x0FFC)



/* Register 0x25 (USER_BYTE1) definition
 * |---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
 * |         Bit 15         |         Bit 14         |         Bit 13         |         Bit 12         |         Bit 11         |         Bit 10         |          Bit 9         |          Bit 8         |          Bit 7         |          Bit 6         |          Bit 5         |          Bit 4         |          Bit 3         |          Bit 2         |          Bit 1         |          Bit 0         |
 * |---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
 * |            0           |            0           |            0           |            0           |                                                                                                                   USE_BYTE1[7:0][9:0]                                                                                                                   |            0           |            0           |
 * |---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
 */

    /* USER_BYTE1 register address */
    #define USER_BYTE1_ADDRESS												((uint8_t) 0x25)

    /* USER_BYTE1 default (reset) value */
    #define USER_BYTE1_DEFAULT												((uint16_t) 0x0000)

    /* USER_BYTE1 register field masks */
    #define USER_BYTE1_USE_BYTE1[7:0]_MASK									((uint16_t) 0x0FFC)



/* Register 0x26 (USER_BYTE2) definition
 * |---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
 * |         Bit 15         |         Bit 14         |         Bit 13         |         Bit 12         |         Bit 11         |         Bit 10         |          Bit 9         |          Bit 8         |          Bit 7         |          Bit 6         |          Bit 5         |          Bit 4         |          Bit 3         |          Bit 2         |          Bit 1         |          Bit 0         |
 * |---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
 * |            0           |            0           |            0           |            0           |                                                                                                                   USE_BYTE2[7:0][9:0]                                                                                                                   |            0           |            0           |
 * |---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
 */

    /* USER_BYTE2 register address */
    #define USER_BYTE2_ADDRESS												((uint8_t) 0x26)

    /* USER_BYTE2 default (reset) value */
    #define USER_BYTE2_DEFAULT												((uint16_t) 0x0000)

    /* USER_BYTE2 register field masks */
    #define USER_BYTE2_USE_BYTE2[7:0]_MASK									((uint16_t) 0x0FFC)



/* Register 0xD0 (STATUS_REGISTER) definition
 * |---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
 * |         Bit 15         |         Bit 14         |         Bit 13         |         Bit 12         |         Bit 11         |         Bit 10         |          Bit 9         |          Bit 8         |          Bit 7         |          Bit 6         |          Bit 5         |          Bit 4         |          Bit 3         |          Bit 2         |          Bit 1         |          Bit 0         |
 * |---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
 * |   NVM_CRC_ALARM_USER   | NVM_CRC_ALARM_INTERNAL |        NVM_BUSY        |            0           |            0           |            0           |            0           |            0           |            0           |            0           |                                           DEVICE_ID[3:0]                                          |                 VERSION_ID[1:0]                 |
 * |---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
 */

    /* STATUS_REGISTER register address */
    #define STATUS_REGISTER_ADDRESS											((uint8_t) 0xD0)

    /* STATUS_REGISTER default (reset) value */
    #define STATUS_REGISTER_DEFAULT											((uint16_t) 0x0014)

    /* STATUS_REGISTER register field masks */
    #define STATUS_REGISTER_NVM_CRC_ALARM_USER_MASK							((uint16_t) 0x8000)
    #define STATUS_REGISTER_NVM_CRC_ALARM_INTERNAL_MASK						((uint16_t) 0x4000)
    #define STATUS_REGISTER_NVM_BUSY_MASK									((uint16_t) 0x2000)
    #define STATUS_REGISTER_DEVICE_ID_MASK									((uint16_t) 0x003C)
    #define STATUS_REGISTER_VERSION_ID_MASK									((uint16_t) 0x0003)

    /* NVM_CRC_ALARM_USER field values */
    #define STATUS_REGISTER_NVM_CRC_ALARM_USER_0NoCRCerrorinuserNVMbits		((uint16_t) 0x0000)
    #define STATUS_REGISTER_NVM_CRC_ALARM_USER_1CRCerrorinuserNVMbits		((uint16_t) 0x8000)

    /* NVM_CRC_ALARM_INTERNAL field values */
    #define STATUS_REGISTER_NVM_CRC_ALARM_INTERNAL_0NoCRCerrorininternalNVM	((uint16_t) 0x0000)
    #define STATUS_REGISTER_NVM_CRC_ALARM_INTERNAL_1CRCerrorininternalNVMbits	((uint16_t) 0x4000)

    /* NVM_BUSY field values */
    #define STATUS_REGISTER_NVM_BUSY_0NVMwriteorloadcompletedWritetodigipotregisters	((uint16_t) 0x0000)
    #define STATUS_REGISTER_NVM_BUSY_allowed								((uint16_t) 0x2000)

    /* DEVICE_ID field values */
    #define STATUS_REGISTER_DEVICE_ID_DeviceIDforTPL1401					((uint16_t) 0x0014)

    /* VERSION_ID field values */
    #define STATUS_REGISTER_VERSION_ID_VersionIDforTPL1401					((uint16_t) 0x0000)



/* Register 0xD1 (GENERAL_CONFIG) definition
 * |---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
 * |         Bit 15         |         Bit 14         |         Bit 13         |         Bit 12         |         Bit 11         |         Bit 10         |          Bit 9         |          Bit 8         |          Bit 7         |          Bit 6         |          Bit 5         |          Bit 4         |          Bit 3         |          Bit 2         |          Bit 1         |          Bit 0         |
 * |---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
 * |            0           |            0           |       DEVICE_LOCK      |            0           |            0           |            0           |            0           |            0           |            0           |            0           |            0           |                  DPOT_PDN[1:0]                  |         REF_EN         |                  OUT_SPAN[1:0]                  |
 * |---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
 */

    /* GENERAL_CONFIG register address */
    #define GENERAL_CONFIG_ADDRESS											((uint8_t) 0xD1)

    /* GENERAL_CONFIG default (reset) value */
    #define GENERAL_CONFIG_DEFAULT											((uint16_t) 0x01F0)

    /* GENERAL_CONFIG register field masks */
    #define GENERAL_CONFIG_DEVICE_LOCK_MASK									((uint16_t) 0x2000)
    #define GENERAL_CONFIG_DPOT_PDN_MASK									((uint16_t) 0x0018)
    #define GENERAL_CONFIG_REF_EN_MASK										((uint16_t) 0x0004)
    #define GENERAL_CONFIG_OUT_SPAN_MASK									((uint16_t) 0x0003)

    /* DEVICE_LOCK field values */
    #define GENERAL_CONFIG_DEVICE_LOCK_0Devicenotlocked						((uint16_t) 0x0000)
    #define GENERAL_CONFIG_DEVICE_LOCK_1Devicelockedthedevicelocksalltheregisters	((uint16_t) 0x2000)

    /* DPOT_PDN field values */
    #define GENERAL_CONFIG_DPOT_PDN_00Powerup								((uint16_t) 0x0000)
    #define GENERAL_CONFIG_DPOT_PDN_01Powerdownto10K						((uint16_t) 0x0008)
    #define GENERAL_CONFIG_DPOT_PDN_10Powerdowntohighimpedance				((uint16_t) 0x0010)
    #define GENERAL_CONFIG_DPOT_PDN_11Powerdownto10K						((uint16_t) 0x0018)

    /* REF_EN field values */
    #define GENERAL_CONFIG_REF_EN_0InternalreferencedisabledVDDisdigipotreferencevoltage	((uint16_t) 0x0000)
    #define GENERAL_CONFIG_REF_EN_1Internalreferenceenableddigipotreference121V	((uint16_t) 0x0004)

    /* OUT_SPAN field values */
    #define GENERAL_CONFIG_OUT_SPAN_00ReferencetoVOUTgain15x				((uint16_t) 0x0000)
    #define GENERAL_CONFIG_OUT_SPAN_01ReferencetoVOUTgain2x					((uint16_t) 0x0001)
    #define GENERAL_CONFIG_OUT_SPAN_10ReferencetoVOUTgain3x					((uint16_t) 0x0002)
    #define GENERAL_CONFIG_OUT_SPAN_11ReferencetoVOUTgain4x					((uint16_t) 0x0003)



/* Register 0xD2 (PROTECT) definition
 * |---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
 * |         Bit 15         |         Bit 14         |         Bit 13         |         Bit 12         |         Bit 11         |         Bit 10         |          Bit 9         |          Bit 8         |          Bit 7         |          Bit 6         |          Bit 5         |          Bit 4         |          Bit 3         |          Bit 2         |          Bit 1         |          Bit 0         |
 * |---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
 * |                                      DEVICE_UNLOCK_CODE[3:0]                                      |            0           |            0           |   DEVICE_CONFIG_RESET  |            0           |            0           |            0           |       NVM_RELOAD       |        NVM_PROG        |                                           SW_RESET[3:0]                                           |
 * |---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
 */

    /* PROTECT register address */
    #define PROTECT_ADDRESS													((uint8_t) 0xD2)

    /* PROTECT default (reset) value */
    #define PROTECT_DEFAULT													((uint16_t) 0x0008)

    /* PROTECT register field masks */
    #define PROTECT_DEVICE_UNLOCK_CODE_MASK									((uint16_t) 0xF000)
    #define PROTECT_DEVICE_CONFIG_RESET_MASK								((uint16_t) 0x0200)
    #define PROTECT_NVM_RELOAD_MASK											((uint16_t) 0x0020)
    #define PROTECT_NVM_PROG_MASK											((uint16_t) 0x0010)
    #define PROTECT_SW_RESET_MASK											((uint16_t) 0x000F)

    /* DEVICE_CONFIG_RESET field values */
    #define PROTECT_DEVICE_CONFIG_RESET_0Deviceconfigurationresetnotinitiated	((uint16_t) 0x0000)
    #define PROTECT_DEVICE_CONFIG_RESET_1Deviceconfigurationresetinitiated	((uint16_t) 0x0200)

    /* RESERVED1 field values */
    #define PROTECT_RESERVED1_Alwayswrite000b								((uint16_t) 0x0000)

    /* NVM_RELOAD field values */
    #define PROTECT_NVM_RELOAD_0NVMreloadnotinitiated						((uint16_t) 0x0000)
    #define PROTECT_NVM_RELOAD_1NVMreloadinitiated							((uint16_t) 0x0020)

    /* NVM_PROG field values */
    #define PROTECT_NVM_PROG_0NVMwritenotinitiated							((uint16_t) 0x0000)
    #define PROTECT_NVM_PROG_1NVMwriteinitiated								((uint16_t) 0x0010)

    /* SW_RESET field values */
    #define PROTECT_SW_RESET_1000Softwareresetnotinitiated					((uint16_t) 0x0008)
    #define PROTECT_SW_RESET_1010Softwareresetinitiated						((uint16_t) 0x000A)



#endif /* TPL1401_H_ */
